=== debian/changelog ===
fuji (1.0.2-1) unstable; urgency=medium

  * New upstream released.
  * Fix FTBFS in testing (undefined: cpu.CPUTimes). (Closes: #829675)
    - Add debian/patches/fix_function_name.
  * Update Standards-Version to 3.9.8.

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Fri, 06 May 2016 17:45:56 +0900

fuji (0.3.0-1) unstable; urgency=low

  * Initial release (Closes: #815928)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Sat, 27 Feb 2016 00:17:55 +0900
