=== debian/control ===
Source: fuji
Section: web
Priority: optional
Maintainer: Nobuhiro Iwamatsu <iwamatsu@debian.org>
Build-Depends: debhelper (>= 9), dh-systemd,
        dh-golang,
        golang-go,
        golang-github-sirupsen-logrus-dev,
        golang-github-pborman-uuid-dev,
        golang-golang-x-net-dev,
        golang-golang-x-sys-dev,
        golang-eclipse-paho-dev,
        golang-github-shirou-gopsutil-dev,
        golang-gopkg-validator.v2-dev,
        golang-codegangsta-cli-dev,
        golang-github-go-ini-ini-dev,
        golang-github-tarm-serial-dev,
        golang-github-burntsushi-toml-dev,
        golang-github-stretchr-testify-dev
Standards-Version: 3.9.8
Homepage: https://github.com/shiguredo/fuji.git
Vcs-Git: git://anonscm.debian.org/collab-maint/fuji.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/fuji.git;a=summary

Package: fuji
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: ${misc:Built-Using}, ${libc:Built-Using}
Description: MQTT gateway which is written by Golang
 fuji is a MQTT gateway which is written by Golang. And MQTT gateway is a
 sensor-MQTT gateway which receives data from sensors and sends that data
 to a MQTT broker.

Package: golang-github-shiguredo-fuji-dev
Architecture: all
Depends: ${misc:Depends}
Built-Using: ${misc:Built-Using}
Description: Externally reusable Go packages included with fuji
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside fuji and only rely on each other or other
 external dependencies to be built.
