=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_GOPKG := github.com/shiguredo/fuji

%:
	dh $@ --buildsystem=golang --with=golang,systemd

override_dh_systemd_enable:
	dh_systemd_enable fuji.service

override_dh_auto_install:
	dh_auto_install # -O--buildsystem=golang

	mv debian/tmp/usr/bin debian/tmp/usr/sbin

	mkdir -p debian/tmp/etc/fuji-gw
	cp config.toml.example debian/tmp/etc/fuji-gw/config.toml

override_dh_auto_test:
